<?
/** 
* HTTP  Ŭ
*/
class Http {
    var $host;
    var $port;
    var $path;
    var $cookie;
    var $variable;
    var $referer;
    var $_header;
    var $auth;
    var $debug;
    var $query;

    # constructor
    function Http($url="") {
        $this->port = 80;
        if($url) $this->setURL($url);
    }

    /**
     * URL Լ
     *
     * @param string $url : URL
     * @return boolean
     */
    function setURL($url) {
        if(!$m = parse_url($url)) return $this->setError("Ľ Ұ URLԴϴ.");
        if($m['scheme'] != "http") return $this->setError("HTTP URL ƴմϴ.");

        $this->host = $m['host'];
        $this->port = ($m['port']) ? $m['port'] : 80;
        $this->path = ($m['path']) ? $m['path'] : "/";
        if($m['query']) {
            $arr1 = explode("&", $m['query']);
            foreach($arr1 as $value) {
                $arr2 = explode("=", $value);
                $this->setParam($arr2[0], $arr2[1]);
            }
        }
        if($m['user'] && $m['pass']) $this->setAuth($m['user'], $m['pass']);
        return true;
    }

    /**
     *  Ѵ.
     *
     * @param string $key : , 迭ε  ִ.
     * @param string $value : 
     */
    function setParam($key, $value="") {
        if(is_array($key)) foreach($key as $k => $v) $this->variable[$k] = $v;
        else $this->variable[$key] = $value;
    }

    /**
     * Referer Ѵ.
     *
     * @param string $referer : Referer
     */
    function setReferer($referer) {
        $this->referer = $referer;
    }

    /**
     * Ű Ѵ.
     *
     * @param string $key : Ű, 迭ε  ִ.
     * @param string $value : Ű
     */
    function setCookie($key, $value="") {
        if(is_array($key)) foreach($key as $k => $v) $this->cookie .= "; $k=$v"; 
        else $this->cookie .= "; $key=$value";
        if(substr($this->cookie, 0, 1) == ";") $this->cookie = substr($this->cookie, 2);
    }

    /**
     * Լ
     *
     * @param string $id : ̵
     * @param string $pass : н
     */
    function setAuth($id, $pass) {
        $this->auth = base64_encode($id.":".$pass);
    }

    /**
     * POST  Լ
     *
     * @return string
     */
    function postMethod() {
        if(is_array($this->variable)) {
            $parameter = "\r\n";
            foreach($this->variable as $key => $val) {
                    $parameter .= trim($key)."=".urlencode(trim($val))."&";
            }
            $parameter .= "\r\n";
        }
        $query .= "POST ".$this->path." HTTP/1.0\r\n";
        $query .= "Host: ".$this->host."\r\n";
        if($this->auth) $query .= "Authorization: Basic ".$this->auth."\r\n";
        if($this->referer) $query .= "Referer: ".$this->referer."\r\n";
        if($this->cookie) $query .= "Cookie: ".$this->cookie."\r\n";
        $query .= "User-agent: PHP/HTTP_CLASS\r\n";
        $query .= "Content-type: application/x-www-form-urlencoded\r\n";
        $query .= "Content-length: ".strlen($parameter)."\r\n";
        if($parameter) $query .= $parameter;
        $query .= "\r\n";
        return $query;
    }

    /**
     * GET  Լ
     *
     * @return string
     */
    function getMethod() {
        if(is_array($this->variable)) {
            $parameter = "?";
            foreach($this->variable as $key => $val) {
                    $parameter .= trim($key)."=".urlencode(trim($val))."&";
            }
            //$parameter = substr($parameter, 0, -1);
        }
        $query = "GET ".$this->path.$parameter." HTTP/1.0\r\n";
        $query .= "Host: ".$this->host."\r\n";
        if($this->auth) $query .= "Authorization: Basic ".$this->auth."\r\n";
        if($this->referer) $query .= "Referer: ".$this->referer."\r\n";
        if($this->cookie) $query .= "Cookie: ".$this->cookie."\r\n";
        $query .= "User-agent: PHP/HTTP_CLASS\r\n";
        $query .= "\r\n";
        return $query;
    }

    /**
     * Ÿ Լ
     *
     * @param string $mode : POST, GET  ϳ ԷѴ.
     * @return string
     */
    function send($mode="GET") {
        
        //  Ѵ.
        $fp = fsockopen($this->host, $this->port, $errno, $errstr, 10);
        if(!$fp) return $this->setError($this->host." ӿ ߽ϴ.");

        // GET, POST Ŀ   ٸ Ѵ.
        if(strtoupper($mode) == "POST") $this->query = $this->postMethod();
        else $this->query = $this->getMethod();

        fputs($fp,$this->query);

        //  κ Ѵ.
        $this->_header = ""; //   ʱȭ Ѵ.
        while(trim($buffer = fgets($fp,1024)) != "") {
            $this->_header .= $buffer;
        }

        // ٵ κ Ѵ.
        while(!feof($fp)) {
            $body .= fgets($fp,1024);
        }

        //  Ѵ.
        fclose($fp);

        return $body;
    }

    /**
     *  ϴ Լ
     *
     * @return string
     */
    function getHeader() {
        return $this->_header;
    }

    /**
     * Ű ϴ Լ
     *
     * @param string $key : Ű
     * @return string or array
     */
    function getCookie($key="") {
        if($key) {
            $pattern = "/".$key."=([^;]+)/";
            if(preg_match($pattern, $this->_header, $ret)) return $ret[1];
        } else {
            preg_match_all("/Set-Cookie: [^\n]+/", $this->_header, $ret);
            return $ret[0];
        }
    }

}
?>